package controleurs;

import dao.ThreadDAO;
import dao.UserDAO;
import dto.MyThread;
import dto.User;
import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import java.io.IOException;
import java.sql.SQLException;
import java.util.List;

@WebServlet("/FollowThread")
public class FollowThread extends HttpServlet {
    public void service(HttpServletRequest req, HttpServletResponse res)
            throws IOException {
        if (req.getSession().getAttribute("user") != null) {
            User user = (User) req.getSession().getAttribute("user");

            UserDAO userDao = new UserDAO();
            ThreadDAO threadDao = new ThreadDAO();

            
            List<Integer> threadsFollowed = null;
            try {
                threadsFollowed = userDao.getThreadsFollowedByUser(user);
            } 
            catch (SQLException sqle) {
                sqle.getStackTrace();
            }
            
            boolean followed = false;
            try {
                if (threadsFollowed.contains(threadDao.getThreadById((Integer.parseInt(req.getParameter("threadid")))))) {
                    followed = true;
                }
                else {
                    followed = false;
                }
            }
            catch (SQLException sqle) {
                sqle.getStackTrace();
            }

            if (!followed) {
                try {
                    userDao.followThread(user, threadDao.getThreadById((Integer.parseInt(req.getParameter("threadid")))));
                    res.sendRedirect("http://localhost:8080/s4a021-web-backend/Discover");
                }
                catch (SQLException sqle) {
                    sqle.getStackTrace();
                }
            }
            else if (followed) {
                try {
                    userDao.unfollowThread(user, threadDao.getThreadById((Integer.parseInt(req.getParameter("threadid")))));
                    res.sendRedirect("http://localhost:8080/s4a021-web-backend/Discover");
                }
                catch (SQLException sqle) {
                    sqle.getStackTrace();
                }
            }
        }
        else {
            res.sendRedirect("http://localhost:8080/s4a021-web-backend/Welcome");
        }
    }
}
