package controleurs;

import java.io.IOException;
import java.sql.SQLException;

import dao.MessageDAO;
import dao.ThreadDAO;
import dao.UserDAO;
import dto.Message;
import dto.User;
import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

@WebServlet("/LikeMessage")
public class LikeMessage extends HttpServlet {
   public void service (HttpServletRequest req, HttpServletResponse res) throws IOException {
       if (req.getSession().getAttribute("user") != null) {
            User user = (User) req.getSession().getAttribute("user");

            UserDAO userDao = new UserDAO();
            ThreadDAO threadDao = new ThreadDAO();
            MessageDAO messageDao = new MessageDAO();

            Message msg = null;

            try {
                messageDao.getMessageByID(
                    Integer.parseInt(req.getParameter("messageid")));
            }
            catch (SQLException sqle) {
                sqle.getStackTrace();
            }

            boolean messageLiked = false;
            try {
                messageLiked = messageDao.isMessageLikedByUser(msg, user);
            }
            catch (SQLException sqle) {
                sqle.getStackTrace();
            }         

            if (!messageLiked) {
                try {
                    userDao.reactToMsg(user, msg);
                }
                catch (SQLException sqle) {
                    sqle.getStackTrace();
                }
            }
            else {
                try {
                    userDao.unreactToMsg(user, msg);
                }
                catch (SQLException sqle) {
                    sqle.getStackTrace();
                }
            }
            res.sendRedirect("http://localhost:8080/s4a021-web-backend/Welcome");
        }
        else {
            res.sendRedirect("http://localhost:8080/s4a021-web-backend/index.html");
        }
   }
}
// A TESTER