package controleurs;

import java.io.IOException;
import java.sql.SQLException;

import dao.ThreadDAO;
import dao.UserDAO;
import dto.User;
import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;


@WebServlet("/PostMessage")
public class PostMessage extends HttpServlet {
    public void service(HttpServletRequest req, HttpServletResponse res) throws IOException {
        User user = (User) req.getSession().getAttribute("user");
        UserDAO userDAO = new UserDAO();
        ThreadDAO threadDAO = new ThreadDAO();

        if (user != null) {
            String message = null;
            int senderID = user.getId();
            int threadID = 0;

            if (req.getParameter("message") != null) {
                message = req.getParameter("message");
            }
            if (req.getParameter("threadid") != null) {
                threadID = Integer.parseInt(req.getParameter("threadid"));
            }

            if (!message.isEmpty() && senderID != 0 && threadID != 0) {
                System.out.println("dans le if");
                try {
                    userDAO.postMessage(user, threadDAO.getThreadById(threadID), message);
                    System.out.println("message posté");
                }
                catch (SQLException sqle) {
                    sqle.getStackTrace();
                }

                res.sendRedirect("http://localhost:8080/s4a021-web-backend/Welcome");
            }
        }
    }
}
