package controleurs;

import dao.UserDAO;
import dto.User;
import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import java.io.IOException;
import java.io.PrintWriter;

@WebServlet("/SignUp")
public class SignUp extends HttpServlet {
    @Override
    public void service(HttpServletRequest req, HttpServletResponse res) throws IOException {
        PrintWriter out = res.getWriter();
        UserDAO userdao = new UserDAO();

        String login = req.getParameter("login");
        String pwd = req.getParameter("pwd");

        if (login.equals("")) out.println("<h1>Invalid Login</h1><button><a href=\"http://localhost:8080/s4a021-web-backend/create.html\">Go Back</a></button>");
        else if (pwd.equals("")) {out.println("<h1>Invalid Password</h1><button><a href=\"http://localhost:8080/s4a021-web-backend/create.html\">Go Back</a></button>");

        }
        else {
            if (!userdao.userExists(login, pwd)) {
                userdao.createUser(login, pwd);
                User user = userdao.getUserByLogs(login, pwd);
                if (user != null && userdao.isDatabased(user)){
                    out.println("<h1>Bienvenue " + user.getUserName() + " !</h1>");
                    req.getSession().setAttribute("user", user);
                    req.getSession().setAttribute("login", login);
                    res.sendRedirect("http://localhost:8080/s4a021-web-backend/Welcome");
                }else{
                    out.println("<h1>Partez de chez moi ?!</h1>");
                    userdao.removeUser(user);
                }
            }
            else {
                out.println("<h1>You already own an account. Please login <a href=\"http://localhost:8080/s4a021-web-backend/index.html\">here</a></h1>");
            }

        }
    }
}
